
#ifndef _GRAPH_H_
#define _GRAPH_H_

#include "libmac6903.h"


typedef struct _Node {
  int outdegree;
  int arraysize;
  /*Adjacency lists (lists of nodes that are connected to a given node)*/
  int   *adjList;
  float *Warcs;
} GraphNode;

typedef struct _Graph {
  int nnodes, nclasses;
  GraphNode *nodes;
  float     *Wnodes;
  float     *Wpred;
} Graph;

/* A utility function that creates a graph of 'nnodes' vertices */
Graph *CreateGraph(int nnodes, int outdegree);

void   DestroyGraph(Graph **graph);

/* Adds an edge to an undirected graph */
void addEdge(Graph *graph, int src, int dest, float w);

/* Adds an arc to a directed graph */
void addDirectedEdge(Graph *graph, int src, int dest, float w);
#endif

