// version 00.00.04

#ifndef _FILELIST_H_
#define _FILELIST_H_

#include "common.h"
#include "arraylist.h"
#include "string_addons.h"

#include <glob.h>

typedef struct _fileList {
  ArrayList *A;
  int n;   //Number of files added.
} FileList;


FileList *CreateFileList(int cap);
void      DestroyFileList(FileList **L);

FileList *ReadFileList(char *filename);
void      WriteFileList(FileList *L,
			char *filename);

void      AddFile(FileList *L, char *file);
char     *GetFile(FileList *L, int index);
bool      HasFile(FileList *L, char *file);


void AddFilesInDir(FileList *L,
		   char *dir);
void AddFilesInDirRec(FileList *L,
		      char *dir);

//It shuffles the files at random.
//Should use "void srand(unsigned int seed);" before calling.
void  RandomizeFileList(FileList *L);

void  ResizeFileList(FileList *L, int n);

//Trims the capacity of this FileList instance 
//to be the list's current size.
void  Trim2SizeFileList(FileList *L);


bool      FileExists(char *file);
void      RemoveFileDirectory(char *file);
void      RemoveFileExtension(char *file);
void      MergeRelativePath(char *dir, char *rel);

#endif

