#ifndef _HEAP_H_
#define _HEAP_H_

#include "common.h"
#include "gpqueue_by_Falcao.h"


typedef struct _heap {
  float *cost;
  char *color;
  int *pixel;
  int *pos;
  int last;
  int n;
  char removal_policy; /* 0 is MINVALUE and 1 is MAXVALUE */
} Heap;


/* Auxiliary Functions */

#define HEAP_DAD(i) ((i - 1) / 2)
#define HEAP_LEFTSON(i) (2 * i + 1)
#define HEAP_RIGHTSON(i) (2 * i + 2)


void SetRemovalPolicyHeap(Heap *H, char policy);
char IsFullHeap(Heap *H);
char IsEmptyHeap(Heap *H);
Heap *CreateHeap(int n, float *cost);
void DestroyHeap(Heap **H);
char InsertHeap(Heap *H, int pixel);
char RemoveHeap(Heap *H, int *pixel);
void UpdateHeap(Heap *H, int p, float value);
void GoUpHeap(Heap *H, int i);
void GoDownHeap(Heap *H, int i);
void ResetHeap(Heap *H);

#endif

