#ifndef _HEAP_LEX_H_
#define _HEAP_LEX_H_

#include "common.h"
#include "heap.h"
#include "gpqueue_by_Falcao.h"


typedef struct _heap_lex {
  float *cost1,*cost2;
  char *color;
  int *pixel;
  int *pos;
  int last;
  int n;
  char removal_policy; /* 0 is MINVALUE and 1 is MAXVALUE */
} Heap_lex;


void SetRemovalPolicyHeap_lex(Heap_lex *H, char policy);
char IsFullHeap_lex(Heap_lex *H);
char IsEmptyHeap_lex(Heap_lex *H);
Heap_lex *CreateHeap_lex(int n, float *cost1, float *cost2);
void DestroyHeap_lex(Heap_lex **H);
char InsertHeap_lex(Heap_lex *H, int pixel);
char RemoveHeap_lex(Heap_lex *H, int *pixel);
void UpdateHeap_lex(Heap_lex *H, int p, float value1, float value2);
void GoUpHeap_lex(Heap_lex *H, int i);
void GoDownHeap_lex(Heap_lex *H, int i);
void ResetHeap_lex(Heap_lex *H);

#endif



