#ifndef _IMAGE_H_
#define _IMAGE_H_

#include "common.h"

typedef struct _pixel {
  int x,y;
} Pixel;


typedef struct _image {
  int *data;
  int **array;
  int nrows; /* numero de linhas (altura) */
  int ncols; /* numero de colunas (largura) */
  int n;     /* numero de pixels */
} Image;


Image  *CreateImage(int ncols,int nrows);
void    DestroyImage(Image **img);
Image  *CloneImage(Image *img);
Image  *ReadImage(char *filename);
void    WriteImage(Image *img, char *filename);

Image  *ConvertToNbits(Image *img, int N);
int     MinimumValue(Image *img);
int     MaximumValue(Image *img);
void    SetImage(Image *img, int value);
bool    ValidPixel(Image *img, int x, int y);

Image  *Threshold(Image *img, int L, int H);

void    DrawRectangle(Image *img, int x1, int y1, int x2, int y2, int val);
void    DrawImageLineDDA(Image *img, int x1, int y1, int xn, int yn, int val);

#endif

