
#include "graph.h"

Graph *CreateGraph(int nnodes, int outdegree){
  Graph *graph = NULL;
  int i;
  graph = (Graph *) calloc(1, sizeof(Graph));
  if(graph == NULL){
    Error(MSG1,"CreateGraph");
  }
  graph->nnodes = nnodes;
  graph->nclasses = 0;
  //graph->Wnodes = Wnodes;
  graph->nodes = (GraphNode *) calloc(nnodes, sizeof(GraphNode));
  if(graph->nodes == NULL){
    Error(MSG1,"CreateGraph");
  }
  for(i = 0; i < nnodes; i++){
    graph->nodes[i].outdegree = 0;
    graph->nodes[i].arraysize = outdegree;
    graph->nodes[i].adjList = AllocIntArray(outdegree);
    graph->nodes[i].Warcs = AllocFloatArray(outdegree);
  }
  return graph;
}


void   DestroyGraph(Graph **graph){
  Graph *aux;
  int i;
  if(graph != NULL){
    aux = *graph;
    if(aux != NULL){
      if(aux->nodes != NULL){
	for(i = 0; i < aux->nnodes; i++){
	  if(aux->nodes[i].adjList != NULL)
	    free(aux->nodes[i].adjList);
	  if(aux->nodes[i].Warcs != NULL)
	    free(aux->nodes[i].Warcs);
	}
	free(aux->nodes);
      }
      free(aux);
      *graph = NULL;
    }
  }
}


void addEdge(Graph *graph, int src, int dest, float w){
  addDirectedEdge(graph, src,  dest, w);
  addDirectedEdge(graph, dest, src,  w);
}


void addDirectedEdge(Graph *graph, int src, int dest, float w){
  GraphNode *s;
  s = &graph->nodes[src];
  s->outdegree++;
  if(s->outdegree > s->arraysize){
    s->adjList = realloc(s->adjList, sizeof(int)*s->outdegree);
    if(s->adjList == NULL)
      Error(MSG1,"addDirectedEdge");
    s->Warcs = realloc(s->Warcs, sizeof(float)*s->outdegree);
    if(s->Warcs == NULL)
      Error(MSG1,"addDirectedEdge");
    s->arraysize = s->outdegree;
  }
  s->adjList[s->outdegree-1] = dest;
  s->Warcs[s->outdegree-1] = w;
}
