#include "common.h"

char *AllocCharArray(int n)
{
  char *v=NULL;
  v = (char *) calloc(n,sizeof(char));
  if (v == NULL)
    Error(MSG1,"AllocCharArray");
  return(v);
}

uchar *AllocUCharArray(int n)
{
  uchar *v=NULL;
  v = (uchar *) calloc(n,sizeof(uchar));
  if (v == NULL)
    Error(MSG1,"AllocUCharArray");
  return(v);
}

ushort *AllocUShortArray(int n)
{
  ushort *v=NULL;
  v = (ushort *) calloc(n,sizeof(ushort));
  if (v == NULL)
    Error(MSG1,"AllocUShortArray");
  return(v);
}

uint *AllocUIntArray(int n)
{
  uint *v=NULL;
  v = (uint *) calloc(n,sizeof(uint));
  if (v == NULL)
    Error(MSG1,"AllocUIntArray");
  return(v);
}

int *AllocIntArray(int n)
{
  int *v=NULL;
  v = (int *) calloc(n,sizeof(int));
  if (v == NULL)
    Error(MSG1,"AllocIntArray");
  return(v);
}

float *AllocFloatArray(int n)
{
  float *v=NULL;
  v = (float *) calloc(n,sizeof(float));
  if (v == NULL)
    Error(MSG1,"AllocFloatArray");
  return(v);
}

double *AllocDoubleArray(int n)
{
  double *v=NULL;
  v = (double *) calloc(n,sizeof(double));
  if (v == NULL)
    Error(MSG1,"AllocDoubleArray");
  return(v);
}

float  *AllocRealArray(int n){
  float *v=NULL;
  v = (float *) calloc(n,sizeof(float));
  if (v == NULL)
    Error(MSG1,"AllocRealArray");
  return(v);
}

void Error(char *msg,char *func){ /* It prints error message and exits
                                    the program. */
  fprintf(stderr,"Error:%s in %s\n",msg,func);
  exit(-1);
}

void Warning(char *msg,char *func){ /* It prints warning message and
                                       leaves the routine. */
 fprintf(stdout,"Warning:%s in %s\n",msg,func);

}

void Change(int *a, int *b){ /* It changes content between a and b */
  int c;
  c  = *a;
  *a = *b;
  *b = c;
}

void UChange(uint *a, uint *b){ /* It changes content between a and b */
  uint c;
  c  = *a;
  *a = *b;
  *b = c;
}


void ULChange(unsigned long long *a, unsigned long long *b){ /* It changes content between a and b */
  unsigned long long c;
  c  = *a;
  *a = *b;
  *b = c;
}

void FChange(float *a, float *b){ /* It changes content between floats a and b */
  float c;
  c  = *a;
  *a = *b;
  *b = c;
}

int NCFgets(char *s, int m, FILE *f) {
  while(fgets(s,m,f)!=NULL)
    if (s[0]!='#') return 1;
  return 0;
}


/**
 * Gera um número inteiro aleatório no intervalo [low,high].
http://www.ime.usp.br/~pf/algoritmos/aulas/random.html
Execute RandomSeed antes, para atualizar a semente.
 **/
int RandomInteger (int low, int high){
  int k;
  double d;

  d = (double) rand () / ((double) RAND_MAX + 1);
  k = d * (high - low + 1);
  return low + k;
}

void RandomSeed() 
{ 
  unsigned int t=0;
  timer *T;

  T = (timer *)malloc(sizeof(timer));
  gettimeofday(T,NULL); 

  if (T!=NULL){
    t = (unsigned int)(T->tv_usec*0.001);
    srand(t);
    free(T);
  }
}

__inline__ float sqrtreal(float x){
  int size;

  size = sizeof(float);
  if(size == sizeof(float))
    return sqrtf(x);
  else if(size == sizeof(double))
    return sqrt(x);
  else
    return (float)sqrt((double)x);
}

int SafeMod(int a, int n)
{
	int r = a % n;

	return (r >= 0) ? r : n+r;
}

int IsPowerOf2(int x)
{
    return (x&(x-1)) == 0;
}

