
#ifndef _FEATMAP_H_
#define _FEATMAP_H_

#include "common.h"
#include "adjacency3.h"
#include "scene.h"
#include "gqueue.h"
#include "sort.h"
#include "complgraph.h"

#include "shared.h"


typedef struct _FeatMap {
  int n;
  int nfeat;
  float **data;
} FeatMap;


FeatMap *CreateFeatMap(int n, int nfeat);
void     DestroyFeatMap(FeatMap **fmap);

/*Creates a copy of the original "FeatMap".*/
FeatMap *CloneFeatMap(FeatMap *fmap);

FeatMap *Scene2FeatMap(Scene *scn);
FeatMap *Scene2FeatMapByLocalIFT(Scene *scn, Scene *mask, int K);
FeatMap *Scene2FeatMapBy5NumSummary(Scene *scn, Scene *mask, float radius);
FeatMap *Scene2FeatMapByKNN(Scene *scn, Scene *mask, int K, float radius);
FeatMap *Scene2FeatMapByMaxMinVal(Scene *scn, Scene *mask, float radius);

inline float DistanceSub(float *fv1, float *fv2, int nfeat);
inline float DistanceL1(float *fv1, float *fv2, int nfeat);
inline float DistanceL2(float *fv1, float *fv2, int nfeat);
inline float DistanceGRAD(float *fv1, float *fv2, int nfeat);


//Converte as caracteristicas do volume em um complete 
//graph ordenado pelo label.
ComplGraph *FeatMap2ComplGraph(FeatMap *fmap, Scene *label);

#endif


