
#ifndef _FIFOQUEUE_H_
#define _FIFOQUEUE_H_

#include "ift.h"

typedef struct _fifoqueue {
  int *data;
  int get, put;
  int nbuckets;
  int nadded;   //Number of elements added.
} FIFOQueue;


/* Generic version with circular and growing features */
FIFOQueue *CreateFQueue(int nbuckets);
void       DestroyFQueue(FIFOQueue **Q);

void       FQueuePush(FIFOQueue *Q, int p);
int        FQueuePop(FIFOQueue *Q); /* returns NIL if empty */
void       FQueueReset(FIFOQueue *Q);
#define    IsEmptyFQueue(Q) (Q->nadded==0)
#define    IsFullFQueue(Q) (Q->nadded==Q->nbuckets)

#endif


