
#ifndef _RCE_H_
#define _RCE_H_

#include "ift.h"

#include "featmap.h"
#include "labeledfeatures.h"


/*Reduced Coulomb energy networks (RCE)*/

typedef struct _RCEClassifier {
  int n;
  FeatMap *fmap;
  float *radius;
  //Distance function
  float (*distance)(float*, float*, int);
} RCEClassifier;


/*"lf" -> The training set.*/
RCEClassifier *RCETraining(LabeledFeatures *lf,
			   float (*distance)(float*, float*, int));

int   RCEClassifySample(RCEClassifier *rce,
			float *fv, int nfeat);
void  RCEClassifySamples(RCEClassifier *rce,
			 LabeledFeatures *lf);

#endif





