
#include "fifoqueue.h"


FIFOQueue *CreateFQueue(int nbuckets){
  FIFOQueue *Q;

  Q = (FIFOQueue *) malloc(sizeof(FIFOQueue));
  if(Q==NULL) Error(MSG1,"CreateFQueue");

  Q->nbuckets = nbuckets;
  Q->nadded = 0;
  Q->put = Q->get = 0;
  Q->data = AllocIntArray(nbuckets);
  return Q;
}

void    DestroyFQueue(FIFOQueue **Q){
  FIFOQueue *aux;
  aux = *Q;
  if(aux!=NULL){
    if(aux->data!=NULL) free(aux->data);
    free(aux);
    *Q = NULL;
  }  
}


void    FQueuePush(FIFOQueue *Q, int p){
  int *new=NULL;
  int n = Q->nbuckets;

  if(!IsFullFQueue(Q)){
    Q->nadded++;
    Q->data[Q->put] = p;
    Q->put = (Q->put + 1) % Q->nbuckets;
  }
  else{ //Doubling queue size.
    new = AllocIntArray(2*n);

    if(Q->get>Q->put){
      memcpy(new, &(Q->data[Q->get]), sizeof(int)*(n-Q->get));
      memcpy(&(new[n-Q->get]), Q->data, sizeof(int)*(Q->put+1));
    }
    else{
      memcpy(new, &(Q->data[Q->get]), sizeof(int)*Q->nadded);
    }
    free(Q->data);
    Q->data = new;
    Q->nbuckets = 2*n;
    Q->put = Q->nadded;
    Q->get = 0;
    FQueuePush(Q, p);
  }
}


int     FQueuePop(FIFOQueue *Q){ /* returns NIL if empty */
  int v;
  if(IsEmptyFQueue(Q)) return NIL;
  v = Q->data[Q->get];
  Q->get = (Q->get + 1) % Q->nbuckets;
  Q->nadded--;
  return v;
}


void    FQueueReset(FIFOQueue *Q){
 Q->put = Q->get = 0;
 Q->nadded = 0;
}


