#ifndef _CLASSIFICATIONDIALOG_H_
#define _CLASSIFICATIONDIALOG_H_

#include "startnewmodule.h"
#include "modulemanual.h"
#include "painthandler.h"

namespace Classification{

class ManualDialog : public BaseDialog{
public:
  typedef enum {NAVIGATOR=0,
		PAINT} ModeType;

  ManualDialog(wxWindow *parent,
	       ModuleManual *mod);
  ~ManualDialog();

  void OnChangeMode(wxCommandEvent& event);
  void OnChangeDrawMode(wxCommandEvent& event);
  void OnReset(wxCommandEvent& event);
  void OnUndo(wxCommandEvent& event);

  void OnAddObj(wxCommandEvent& event);
  void OnDelete(wxCommandEvent& event);
  void OnChangeColor(wxCommandEvent& event);
  void OnChangeVisibility(wxCommandEvent& event);

  void OnCancel(wxCommandEvent& event);
  void OnOk(wxCommandEvent& event);
  void OnSize(wxSizeEvent& event);
  void ChangeSelection(wxPanel *bkg);

  ManualDialog::ModeType GetOperationMode();
  Manual::DrawMode GetDrawMode();

  AdjRel   *GetBrush();
  wxCursor *GetBrushCursor(int zoom);
  void      NextBrush();
  void      PrevBrush();

  ManualElementDialog *elem_dialog;

private:
  wxScrolledWindow *CreateObjectPanel();
  void              DestroyObjectPanel();

  int id_but;
  int id_but2;
  int id_bp;
  int id_res;
  int id_undo;
  int id_add;
  PaintHandler       *xhandler;
  PaintHandler       *yhandler;
  PaintHandler       *zhandler;
  ModuleManual       *mod;

  BitmapRadioButton  *but;
  BitmapRadioButton  *but2;
  BrushPicker        *bPicker;
  wxButton           *undo;
  wxButton           *res;
  wxButton           *addobj;
  BasePanel  *panel;

  //ObjectPanel:
  wxScrolledWindow *objPanel;
  wxPanel            **v_panel_bkg;
  AlphaColourButton  **v_but_color;
  BitmapToggleButton **v_but_eye;
  wxBitmapButton     **v_but_trash;

DECLARE_EVENT_TABLE()
  };

};
