
#ifndef _MIPCANVAS_H_
#define _MIPCANVAS_H_

#include "startnewmodule.h"
#include "rendercanvas.h"


namespace MIP{

  typedef struct _Face {
    Point V;  //vertex
    Vector N; //normal
    int fixedindex; //x=0,y=1,z=2
    int fixedval;
  } Face;

  class MIPCanvas : public RenderCanvas {
  public:
    MIPCanvas(wxWindow *parent);

    //Draw phong shading.
    CImage *Render2CImage(bool dataChanged, int skip);
    void drawRender(bool dataChanged, int skip);
    void SetInteractionHandler(InteractionHandler *handler);
    int  GetSurfaceVoxel(int p);
    Vector Vpj,Vpi;

  protected:
    InteractionHandler *defaulthandler;
    Vector light;
    float ka;
    float kd;
    float ks;
    int   sre;
    float zgamma;
    float zstretch;
    float *zbuf;
    int   *vxbuf;
    float *normals;

    bool    ValidVoxelInMBB(Voxel v, Voxel MBB_min, Voxel MBB_max);
    int     xgray(int value);
    float   phong_specular(float angcos, int n);
    void    render_calc_normal(int x,int y,int rw,
			       int *vxbuf, float *out);
    CImage *Anaglyph3D(CImage *cimg_l, CImage *cimg_r);
  };
} //end MIP namespace

#include "mipview.h"
#include "miphandler.h"

#endif

