
#include "miphandler.h"

namespace MIP{

  MIPHandler :: MIPHandler(MIPCanvas *canvas){
    this->canvas = canvas;
  }

  MIPHandler :: ~MIPHandler(){}

  void MIPHandler :: OnLeftClick(int p){
    Voxel Cut;
    int q;

    q = canvas->GetSurfaceVoxel(p);
    if(q!=NIL){
      Cut.x = VoxelX(APP->Data.den[0], q);
      Cut.y = VoxelY(APP->Data.den[0], q);
      Cut.z = VoxelZ(APP->Data.den[0], q);
      APP->Set2DViewSlice(Cut);
      APP->Refresh2DCanvas();
    }
  }

  void MIPHandler :: OnRightClick(int p){}

  void MIPHandler :: OnMiddleClick(int p){
    int i;
    //canvas->ReadRotationMatrix("rotation.txt");
    for(i=0; i<20; i++){
      canvas->drawRender(true, 1);
    }
  }

  void MIPHandler :: OnLeftDrag(int p, int q){}

  void MIPHandler :: OnRightDrag(int p, int q){
    int x1,x2,y1,y2,w,h;
    float ax,ay;

    canvas->GetImageSize(&w, &h);
    x1 = p%w;
    y1 = p/w;
    x2 = q%w;
    y2 = q/w;
    ax = (float)(x2 - x1)*(PI / 180.0);
    ay = (float)(y2 - y1)*(PI / 180.0);

    canvas->Rotate( ax, canvas->Vpi);
    canvas->Rotate(-ay, canvas->Vpj);
    canvas->drawRender(true, 1);
  }


  void MIPHandler :: OnLeftRelease(int p){
  }

  void MIPHandler :: OnRightRelease(int p){
    canvas->drawRender(true, 1);

    /* Grava matriz de rotacao */
    //canvas->WriteRotationMatrix("rotation.txt");
  }

  void MIPHandler :: OnMiddleRelease(int p){
  }


  void MIPHandler :: OnMouseMotion(int p){
    APP->Window->SetStatusText(_T("Mouse Left: Navigate, Mouse Right: Rotate"));
  }

} //end MIP namespace

