
#include "modulemip.h"

namespace MIP{

  ModuleMIP :: ModuleMIP()
    : View3DModule(){
    SetName((char *)"Point Perspective Projection and Maximum Intensity Projection (MIP)");
    SetAuthor((char *)"Paulo A.V. Miranda");
    SoftwareVersion ver(0,8,0);
    SetVersion(ver);
    panel = NULL;
  }


  ModuleMIP :: ~ModuleMIP(){}


  wxPanel* ModuleMIP :: GetViewPanel(wxWindow *parent){
    MIPView *view = new MIPView(parent);
    panel = (wxPanel*)view;
    return panel;
  }

  void ModuleMIP :: SetInteractionHandler(InteractionHandler *handler){
    MIPView *view;

    view = (MIPView *)panel;
    view->canvas->SetInteractionHandler(handler);
  }

  void ModuleMIP :: Start(){
    this->Refresh(true, 1.0);
  }

  bool ModuleMIP :: Stop(){
    return true;
  }

  void ModuleMIP :: Refresh(bool dataChanged, float quality){
    MIPView *view;
    MIPCanvas *scanvas;
    int skip;

    view = (MIPView *)panel;
    scanvas = (MIPCanvas *)view->canvas;
    skip = ROUND((1.0-quality)*11)+1;
    scanvas->drawRender(dataChanged, skip);
  }

  void ModuleMIP :: Zoomin(){
    MIPView *view;

    view = (MIPView *)panel;
    view->canvas->Zoomin();
  }

  void ModuleMIP :: Zoomout(){
    MIPView *view;

    view = (MIPView *)panel;
    view->canvas->Zoomout();
  }


  void ModuleMIP :: SetZoomLevel(float zoom){
    MIPView *view;

    view = (MIPView *)panel;
    view->canvas->SetZoomLevel(zoom);
  }

  float ModuleMIP :: GetZoomLevel(){
    MIPView *view;
    
    view = (MIPView *)panel;
    return view->canvas->GetZoomLevel();
  }


  CImage * ModuleMIP :: CopyAsCImage(){
    MIPView *view;
    CImage *cimg;

    view = (MIPView *)panel;
    cimg = view->canvas->CopyAsCImage();
    return cimg;
  }


} //end MIP namespace



