
#include "rayleapingview.h"

#include "../xpm/glasses.xpm"

namespace Rayleaping{

  RayleapingView :: RayleapingView(wxWindow *parent) 
    : BasePanel(parent){
    int id1;

    canvas  = new RayleapingCanvas(this);

    id1 = APP->idManager->AllocID();

    wxBitmap *bm = new wxBitmap(glasses_xpm);
    but3D = new BitmapToggleButton(this, id1, bm, bm);
    but3D->SetBkgColor(true, 0x808080);
    but3D->SetValue(false);

    wxBoxSizer *hsizer = new wxBoxSizer(wxHORIZONTAL);
    hsizer->AddSpacer(5);
    hsizer->Add(but3D, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);

    sizer->Add(canvas, 1, wxEXPAND);
    sizer->Add(hsizer, 0, wxALIGN_LEFT|wxEXPAND);

    SetSizer(sizer, true);
    sizer->SetSizeHints(this);
    sizer->Layout();

    Connect( id1, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(RayleapingView::OnChange3D),
	     NULL, NULL );
  }


  RayleapingView :: ~RayleapingView(){
    int id1 = but3D->GetId();
    Disconnect( id1, wxEVT_COMMAND_BUTTON_CLICKED,
		wxCommandEventHandler(RayleapingView::OnChange3D), 
		NULL, NULL );
    APP->idManager->FreeID(id1);
  }

  void RayleapingView :: OnChange3D(wxCommandEvent& event){
    APP->Refresh3DCanvas(false, 1.0);
  }


} //end Rayleaping namespace




