
#ifndef _CLASSIFYDIALOG_H_
#define _CLASSIFYDIALOG_H_

#include "startnewmodule.h"
#include "ModuleClassify.h"

namespace Classify {

enum{OPFClustering = 0, OPFKNNClassify, CLUTO, SPECTRAL, SPECTRAL_NCLUSTERS, SPECTRAL_NORMALIZEDCUT, KMEANS, GFT};

class ClassificationDialog : public BaseDialog{
public:
    ClassificationDialog(wxWindow *parent);
    ~ClassificationDialog();

  void OnCancel(wxCommandEvent& event);
  void OnOk(wxCommandEvent& event);
  void OnSize(wxSizeEvent& event);
  void OnClose(wxCommandEvent& event);

  void OnChoice(wxCommandEvent& event);
  void OnSpinNClusters(wxCommandEvent& event);
  void OnSpinKmax(wxCommandEvent& event);
  void OnSpinfvol(wxCommandEvent& event);
  void OnChoiceClMethod(wxCommandEvent& event);
  void OnChoiceSim(wxCommandEvent& event);
  void OnChoiceCrFun(wxCommandEvent& event);
  void OnChoiceViewType(wxCommandEvent& event);
  void OnClickDefault(wxCommandEvent& event);
  void OnChoiceSpecSimFun(wxCommandEvent& event);
  void OnSpinSpectralParam(wxCommandEvent& event);
  void OnSpinSpectralCutValue(wxCommandEvent& event);
  void OnSpinStopValue(wxCommandEvent& event);
  void OnSpinOutdegree(wxCommandEvent& event);
  void OnSpinPparam(wxCommandEvent& event);
  void OnSpinQparam(wxCommandEvent& event);
  void OnSpinGFTsigma(wxCommandEvent& event);
  void OnChoiceArcDen(wxCommandEvent& event);
  void OnChoiceSGDen(wxCommandEvent& event);
  void OnChoiceArcW(wxCommandEvent& event);
  void OnChoiceOPFftype(wxCommandEvent& event);
  void OnChoiceGFTGraph(wxCommandEvent& event);
  void OnCheckCorrectWeights(wxCommandEvent& event);
  void OnCheckOPFSigma(wxCommandEvent& event);

  void RefreshDialog();
  void RefreshOptions();


private:
  wxScrolledWindow *CreateMethodsPanel();
  void              DestroyMethodsPanel();
  wxScrolledWindow *CreateOptionsPanel();
  void              DestroyOptionsPanel();

  //ModuleManual *mod;
  BasePanel  *panel;

  //ElementPanel:
  wxScrolledWindow *clasPanel;
  wxPanel            **v_panel_bkg;
  wxChoice         *ch, *chcrfun;
  SpinFloat        *spfparam_spec, *spfparam_nspec, *spfSigma;
  wxRadioBox *rbView;
  wxStatusBar *sbAcc;

  int selection;

  int controlint[10];
  int NClusters;
  int Kmax, outdegree;
  int GFTfunc[3];
  int GFTGraph;
  int OPFftype;
  float fvol;           //utilize std::vector
  float param, SpectralCutValue, stop_value, pparam, qparam, GFTsigma;
  bool CorrectWeights, OPFsigma;

  //OptionsPanel:
  wxScrolledWindow *optPanel;

DECLARE_EVENT_TABLE()
};

}       //End Classify Namespace
#endif

