#include "ModuleClassify.h"
//#include "manualopt.h"
#include "ClassificationDialog.h"

#ifdef _WIN32
#include <windows.h>
#endif

namespace Classify{

  ModuleClassify :: ModuleClassify()
    : ClassifyModule(){
    SetName((char *)"Classify");
    SetAuthor((char *)"Carlos Augusto Prete Junior");
    SoftwareVersion ver(2,0,0);
    SetVersion(ver);

    optDialog = NULL;
  }


  ModuleClassify :: ~ModuleClassify(){
  }

  void ModuleClassify :: Start(){
    //int r;

    APP->EnableObjWindow(false);
    APP->ResetData();

    this->active = true;
    this->AllocData();
    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);

  }


  void ModuleClassify :: AllocData(){
    int x,y,w,h;

    if(optDialog!=NULL) delete optDialog;
    ClassificationDialog *dialog = new ClassificationDialog(APP->Window);
    optDialog = (BaseDialog*)dialog;
    optDialog->Show(true);
    APP->Window->GetPosition(&x, &y);
    APP->Window->GetSize(&w, &h);
    optDialog->Move(MAX(x-20,0), h/2); //wxDefaultCoord);
  }



  bool ModuleClassify :: Stop(){
  /*static const char *title = {"Keep Classification?"};
    static const char *msg = {
      "You are about to leave the classify module.\nSave changes?"};

    if(!this->active) return true;

    wxString wxtitle(title, wxConvUTF8);
    wxString wxmsg(msg, wxConvUTF8);

    wxMessageDialog dialog(APP->Window,
			   wxmsg, wxtitle,
			   wxYES_NO | wxICON_QUESTION,
			   wxDefaultPosition);

    if(dialog.ShowModal() == wxID_YES)*/
      this->Finish();

    return true;
  }


  void ModuleClassify :: FreeData(){
    //APP->DetachOptPanel(optPanel);
    APP->SetDefaultInteractionHandler();
    APP->EnableObjWindow(true);
    APP->ResetData();
    //APP->DrawSegmObjects();
    this->active = false;

    optDialog->Show(false);
    if(optDialog!=NULL)
      optDialog->Destroy(); //delete optDialog;
    optDialog = NULL;
  }


  void ModuleClassify :: Finish(){
    this->FreeData();
  }



  void ModuleClassify :: Reset(){
    wxMessageDialog dialog(APP->Window,
			   _T("Current classification will be lost.\nAre you sure you want to reset?"),
			   _T("Reset classification?"),
			   wxYES_NO | wxICON_QUESTION,
			   wxDefaultPosition);

    if(dialog.ShowModal() == wxID_YES){
      APP->ResetData();
      APP->Refresh2DCanvas();
      APP->Refresh3DCanvas(true, 1.0);
    }
  }


} //end Manual namespace


