
#include "manualdialog.h"

#include "../xpm/paint.xpm"
#include "../xpm/nav.xpm"

#include "../xpm/spline.xpm"
#include "../xpm/gspline.xpm"
#include "../xpm/opf.xpm"
#include "../xpm/circumference.xpm"
#include "../xpm/spiral.xpm"
#include "../xpm/bezier.xpm"

#include "../xpm/eye.xpm"f
#include "../xpm/noteye.xpm"
#include "../xpm/trash.xpm"
#include "../xpm/dice.xpm"
#include "../xpm/GaussianDistribution.xpm"
#include "../xpm/LinearDistribution.xpm"
#include "../xpm/LinearSpline2.xpm"

namespace Manual{

  BEGIN_EVENT_TABLE(ManualDialog, BaseDialog)
    EVT_SIZE    (       ManualDialog::OnSize)
  END_EVENT_TABLE()


ManualDialog :: ManualDialog(wxWindow *parent,
			       ModuleManual *mod)
  : BaseDialog(parent, (char *)"Draw"){
    wxBitmap *bm[2];
    wxBitmap *bm2[4];
    wxBitmap *bm3[5];
    wxSize size(300, 450);
    wxColour wxcolor;

    this->SetMinSize(size);
    this->SetSize(size);
    this->mod = mod;
    this->elem_dialog = NULL;

    panel = new BasePanel(this);
    panel->Show(true);

    xhandler = new PaintHandler('x', mod);
    yhandler = new PaintHandler('y', mod);
    zhandler = new PaintHandler('z', mod);

    bm[0] = new wxBitmap(nav_xpm);
    bm[1] = new wxBitmap(paint_xpm);

    bm2[0] = new wxBitmap(spline_xpm);
    bm2[1] = new wxBitmap(bezier_xpm);
    bm2[2] = new wxBitmap(circumference_xpm);
    bm2[3] = new wxBitmap(spiral_xpm);
    //bm2[4] = new wxBitmap(gspline_xpm);
    //bm2[5] = new wxBitmap(opf_xpm);
    //bm2[6] = new wxBitmap(nav_xpm);

    bm3[0] = new wxBitmap(GaussianDistribution_xpm);
    bm3[1] = new wxBitmap(gspline_xpm);
    bm3[2] = new wxBitmap(LinearDistribution_xpm);
    bm3[3] = new wxBitmap(LinearSpline2_xpm);
    bm3[4] = new wxBitmap(opf_xpm);

    id_but  = APP->idManager->AllocID();
    id_but2 = APP->idManager->AllocID();
    id_but3 = APP->idManager->AllocID();
    id_bp   = APP->idManager->AllocID();
    id_res  = APP->idManager->AllocID();
    id_undo = APP->idManager->AllocID();
    id_add  = APP->idManager->AllocID();
    but = new BitmapRadioButton(panel, id_but, bm, 2);
    but2 = new BitmapRadioButton(panel, id_but2, bm2, 4);
    but3 = new BitmapRadioButton(panel, id_but3, bm3, 5);
    but->SetSelection(0);
    but2->SetSelection(0);
    but3->SetSelection(-1);

    wxCheckBox *chbox;
    chbox = new wxCheckBox(panel, wxID_ANY, _T("Simple Distribution"),
    wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("WxCheckBox"));
    chbox->SetValue(true);

    size.SetHeight(30);
    size.SetWidth(60);

    addobj = new wxButton(panel,  id_add, _T("Add"), wxDefaultPosition,
			  size, wxBU_EXACTFIT,
			  wxDefaultValidator, _T("butAdd"));

    res = new wxButton(panel, id_res, _T("Reset"), wxDefaultPosition,
		       size, wxBU_EXACTFIT,
		       wxDefaultValidator, _T("butReset"));
    undo = new wxButton(panel, id_undo, _T("Undo"), wxDefaultPosition,
			size, wxBU_EXACTFIT,
			wxDefaultValidator, _T("butUndo"));

    SetColor(&wxcolor, 0xff0000);
    res->SetBackgroundColour(wxcolor);
    SetColor(&wxcolor, 0xffffff);
    res->SetForegroundColour(wxcolor);
    SetColor(&wxcolor, 0xffff00);
    undo->SetBackgroundColour(wxcolor);


    bPicker = new BrushPicker(panel, id_bp, true);
    wxStaticText *tbp = new wxStaticText(panel, -1, _T("Density Radius"), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText1"));

    wxBoxSizer *hbs2 = new wxBoxSizer(wxHORIZONTAL);
    hbs2->Add(tbp,     0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL);
    hbs2->Add(bPicker, 0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL);


    wxBoxSizer *hbs3 = new wxBoxSizer(wxHORIZONTAL);
    hbs3->Add(res,  0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL);
    hbs3->Add(undo, 0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL);

    wxStaticBoxSizer *tools_sizer;
    tools_sizer = new wxStaticBoxSizer(wxVERTICAL, panel,
				       _T("Tools"));
    wxStaticBoxSizer *options_sizer;
    options_sizer = new wxStaticBoxSizer(wxVERTICAL, panel,
					 _T("Options"));

    tools_sizer->Add(but,    0, wxALIGN_CENTER);
    tools_sizer->Add(but2,  0, wxALIGN_CENTER);
    tools_sizer->Add(but3,  0, wxALIGN_CENTER);
    tools_sizer->Add(hbs2,   0, wxALIGN_CENTER);

    options_sizer->Add(hbs3,   0, wxALIGN_CENTER);
    options_sizer->Add(chbox, 0, wxEXPAND);

    panel->sizer->Add(addobj, 0, wxALIGN_RIGHT);
    panel->sizer->Add(tools_sizer,   0, wxEXPAND);
    panel->sizer->Add(options_sizer, 0, wxEXPAND);
    panel->sizer->AddSpacer(20);

    panel->sizer->SetSizeHints(panel);
    panel->sizer->Layout();

    this->AddPanel(panel, 0);
    //----------------------------------
    size.SetHeight(30);
    size.SetWidth(60);

    /*addobj = new wxButton(this, id_add, _T("Add"), wxDefaultPosition,
			  size, wxBU_EXACTFIT,
			  wxDefaultValidator, _T("butAdd"));
    this->sizer->Prepend(addobj, 0, wxALIGN_RIGHT);*/
    //----------ObjectPanel-------------
    objPanel = this->CreateObjectPanel();
    this->AddPanel((wxPanel *)objPanel);

    ChangeSelection(v_panel_bkg[mod->obj_sel]);
    //----------------------------------

    Connect( id_but, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualDialog::OnChangeMode),
	     NULL, NULL );
    Connect ( id_but2, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualDialog::OnChangeDrawMode),
	     NULL, NULL );
    Connect ( id_but3, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualDialog::OnChangeDrawMode2),
	     NULL, NULL );
    Connect( id_res, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualDialog::OnReset),
	     NULL, NULL );
    Connect( id_undo, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualDialog::OnUndo),
	     NULL, NULL );
    Connect( id_add, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualDialog::OnAddObj),
	     NULL, NULL );
    Connect( chbox->GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED,
         wxCommandEventHandler(ManualDialog::OnCheckSimpleDistribution),
         NULL, NULL);
    //----------------------------------
    this->elem_dialog = new ManualElementDialog(this, this->mod);
    this->elem_dialog->Show(true);


    int x,y,w,h;
    APP->Window->GetPosition(&x, &y);
    APP->Window->GetSize(&w, &h);
    (this->elem_dialog)->Move(MAX(x+40,0), h/2); //wxDefaultCoord);

    //----------------------------------
    /*
    int i;
    unsigned int j;
    //if(APP->Control.ClassColor.size() > 1)
    for(j=0;j<APP->Control.ClassColor.size();j++) {
    if(mod->nobjs>=MAX_OBJS) break;

    i = mod->nobjs;
    mod->obj_visibility[i] = true;
    mod->obj_color[i] = APP->Control.ClassColor[j];
    sprintf(mod->obj_name[i], "class %d", i+1);
    //---------------------------
    this->DestroyObjectPanel();

    APP->SetLabelColour(i+1, mod->obj_color[i]);
    mod->nobjs++;
    mod->obj_sel = i;
    if(mod->obj_sel<0) mod->obj_sel = 0;

    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);

    this->SetMinSize(size);
    this->SetSize(size);
    objPanel = this->CreateObjectPanel();
    this->AddPanel((wxPanel *)objPanel);
    ChangeSelection(v_panel_bkg[mod->nobjs-1]); // last one
    //this->Fit();
    this->SetMinSize(size);
    this->SetSize(size);
    this->Update();

    if(elem_dialog != NULL)
      elem_dialog->RefreshDialog();
    }*/


    APP->UpdateDensityScene();
    APP->UpdateLabel();
    this->Update();


  }

  ManualDialog::~ManualDialog(){
    Disconnect( id_but, wxEVT_COMMAND_BUTTON_CLICKED,
		wxCommandEventHandler(ManualDialog::OnChangeMode),
		NULL, NULL );
    Disconnect( id_res, wxEVT_COMMAND_BUTTON_CLICKED,
		wxCommandEventHandler(ManualDialog::OnReset),
		NULL, NULL );
    Disconnect( id_undo, wxEVT_COMMAND_BUTTON_CLICKED,
		wxCommandEventHandler(ManualDialog::OnUndo),
		NULL, NULL );
    Disconnect( id_add, wxEVT_COMMAND_BUTTON_CLICKED,
		wxCommandEventHandler(ManualDialog::OnAddObj),
		NULL, NULL );
    APP->idManager->FreeID(id_but);
    APP->idManager->FreeID(id_bp);
    APP->idManager->FreeID(id_res);
    APP->idManager->FreeID(id_undo);
    APP->idManager->FreeID(id_add);
    APP->SetDefaultInteractionHandler();

    delete xhandler;
    delete yhandler;
    delete zhandler;

    free(v_panel_bkg);
    free(v_but_color);
    free(v_but_eye);
    free(v_but_trash);

    if(elem_dialog != NULL){
      delete elem_dialog;
      elem_dialog = NULL;
    }
  }

  wxScrolledWindow *ManualDialog::CreateObjectPanel(){
    int i,n,id,w,h,wm=200;
    wxSize size(220, 120);
    wxPanel *bkg;

    wxScrolledWindow *swind = new wxScrolledWindow(this, wxID_ANY,
						   wxDefaultPosition,
						   wxDefaultSize,
						   wxHSCROLL | wxVSCROLL,
						   _T("scrolledWindow"));
    swind->SetMinSize(size);
    wxBitmap *bmeye   = new wxBitmap(eye_xpm);
    wxBitmap *bmneye  = new wxBitmap(noteye_xpm);
    wxBitmap *bmtrash = new wxBitmap(trash_xpm);

    //n = mod->nobjs;
    n = APP->Control.ClassColor.size();

    if(n>0){
      v_panel_bkg = (wxPanel **)malloc(sizeof(wxPanel *)*n);
      v_but_color = (AlphaColourButton **)malloc(sizeof(AlphaColourButton *)*n);
      v_but_eye = (BitmapToggleButton **)malloc(sizeof(BitmapToggleButton *)*n);
      v_but_trash = (wxBitmapButton **)malloc(sizeof(wxBitmapButton *)*n);
    }
    else{
      v_panel_bkg = NULL;
      v_but_color = NULL;
      v_but_eye   = NULL;
      v_but_trash = NULL;
    }

    swind->SetScrollRate(5, 5);
    swind->Scroll(0, 0);
    swind->SetVirtualSize(200,10+MAX(40*n,40));

    for(i=0; i<n; i++){
      size.SetHeight(wxDefaultCoord);
      size.SetWidth(200);
      bkg = new ObjBkgPanel(swind,
			    wxPoint(10,10+40*i),
			    wxDefaultSize,
			    this, 0);
      //bkg->SetSize(size);
      bkg->SetMinSize(size);
      v_panel_bkg[i] = bkg;
      v_but_color[i] = new AlphaColourButton(bkg, wxID_ANY);
      v_but_eye[i] = new BitmapToggleButton(bkg, wxID_ANY,
					    bmneye, bmeye);
      v_but_trash[i] = new wxBitmapButton(bkg, wxID_ANY, *bmtrash,
					  wxDefaultPosition, wxDefaultSize,
					  wxBU_AUTODRAW, wxDefaultValidator,
					  _T("trash"));
      v_but_color[i]->SetValue(mod->obj_color[i]);
      v_but_color[i]->SetAlpha(255);
      v_but_eye[i]->SetValue(mod->obj_visibility[i]);

      id = v_but_trash[i]->GetId();
      Connect( id, wxEVT_COMMAND_BUTTON_CLICKED,
	       wxCommandEventHandler(ManualDialog::OnDelete),
	       NULL, NULL );

      id = v_but_color[i]->GetId();
      Connect( id, wxEVT_COMMAND_BUTTON_CLICKED,
	       wxCommandEventHandler(ManualDialog::OnChangeColor),
	       NULL, NULL );

      id = v_but_eye[i]->GetId();
      Connect( id, wxEVT_COMMAND_BUTTON_CLICKED,
	       wxCommandEventHandler(ManualDialog::OnChangeVisibility),
	       NULL, NULL );

      wxString *wxstr = new wxString(mod->obj_name[i], wxConvUTF8);
      ObjLabel *tname = new ObjLabel(bkg, *wxstr, this, 0);
      size.SetHeight(wxDefaultCoord);
      size.SetWidth(120);
      //tname->SetSize(size);
      tname->SetMinSize(size);
      wxBoxSizer *hsizer = new wxBoxSizer(wxHORIZONTAL);
      hsizer->Add(v_but_eye[i],   0, wxALIGN_LEFT|wxEXPAND);
      hsizer->Add(v_but_trash[i], 0, wxALIGN_RIGHT|wxEXPAND);
      hsizer->Add(v_but_color[i], 0, wxALIGN_LEFT|wxEXPAND);
      hsizer->AddSpacer(10);
      hsizer->Add(tname,          1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);

      bkg->SetSizer(hsizer, true);
      hsizer->SetSizeHints(bkg);
      hsizer->Layout();

      bkg->GetSize(&w, &h);
      if(w>wm) wm = w;
    }

    for(i=0; i<n; i++){
      size.SetHeight(wxDefaultCoord);
      size.SetWidth(wm);
      (v_panel_bkg[i])->SetSize(size);
    }
    swind->SetVirtualSize(wm,10+MAX(40*n,40));
    wxPaintDC paintDC(swind);
    swind->DoPrepareDC(paintDC);

    delete bmeye;
    delete bmneye;
    delete bmtrash;

    return (swind);
  }


  void ManualDialog::DestroyObjectPanel(){
    int i,n,id;

    n = mod->nobjs;
    for(i=0; i<n; i++){
      if(v_but_trash==NULL) break;
      id = v_but_trash[i]->GetId();
      Disconnect( id, wxEVT_COMMAND_BUTTON_CLICKED,
		  wxCommandEventHandler(ManualDialog::OnDelete),
		  NULL, NULL );
      if(v_but_color==NULL) break;
      id = v_but_color[i]->GetId();
      Disconnect( id, wxEVT_COMMAND_BUTTON_CLICKED,
		  wxCommandEventHandler(ManualDialog::OnChangeColor),
		  NULL, NULL );
      if(v_but_eye==NULL) break;
      id = v_but_eye[i]->GetId();
      Disconnect( id, wxEVT_COMMAND_BUTTON_CLICKED,
		  wxCommandEventHandler(ManualDialog::OnChangeVisibility),
		  NULL, NULL );
    }
    if(v_panel_bkg!=NULL) free(v_panel_bkg);
    if(v_but_color!=NULL) free(v_but_color);
    if(v_but_eye!=NULL)   free(v_but_eye);
    if(v_but_trash!=NULL) free(v_but_trash);
    v_panel_bkg = NULL;
    v_but_color = NULL;
    v_but_eye   = NULL;
    v_but_trash = NULL;

    if(objPanel!=NULL){
      if(sizer->GetItem(objPanel,false)!=NULL)
	sizer->Detach(objPanel);
      objPanel->Destroy();
      objPanel = NULL;
    }
  }


  void ManualDialog :: OnAddObj(wxCommandEvent& event){
    wxSize size(240, 380);
    int i;

    if(mod->nobjs>=MAX_OBJS) return;

    i = mod->nobjs;
    mod->obj_visibility[i] = true;
    mod->obj_color[i] = randomColor();
    APP->Control.ClassColor.push_back(mod->obj_color[i]);
    sprintf(mod->obj_name[i], "class %d", i+1);
    //---------------------------
    this->DestroyObjectPanel();

    APP->SetLabelColour(i+1, mod->obj_color[i]);
    mod->nobjs++;
    mod->obj_sel = i;
    if(mod->obj_sel<0) mod->obj_sel = 0;

    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);

    //this->SetMinSize(size);
    //this->SetSize(size);
    objPanel = this->CreateObjectPanel();
    this->AddPanel((wxPanel *)objPanel);
    ChangeSelection(v_panel_bkg[mod->nobjs-1]); // last one
    //this->Fit();
    //this->SetMinSize(size);
    //this->SetSize(size);

    if(elem_dialog != NULL)
      elem_dialog->RefreshDialog();
  }


  void ManualDialog :: OnDelete(wxCommandEvent& event){
    wxSize size(240, 380);
    char msg[1024];
    int i,n,id;

    id = event.GetId();
    n = mod->nobjs;
    for(i=0; i<n; i++){
      if(id == v_but_trash[i]->GetId())
	break;
    }
    if(i<n){
      sprintf(msg,"Do you really wish to delete the %s?",mod->obj_name[i]);

      wxString wxmsg(msg, wxConvUTF8);
      wxMessageDialog *dialog = new wxMessageDialog(this, wxmsg,
						    _T("Delete Confirmation"),
						    wxYES_NO | wxICON_QUESTION,
						    wxDefaultPosition);
      if(dialog->ShowModal() == wxID_YES){
	this->DestroyObjectPanel();
	mod->DeleteObj(i);

	this->SetMinSize(size);
	this->SetSize(size);
	objPanel = this->CreateObjectPanel();
	this->AddPanel((wxPanel *)objPanel);
	if(mod->obj_sel>=0 && v_panel_bkg!=NULL)
	  ChangeSelection(v_panel_bkg[mod->obj_sel]);
	//this->Fit();
	//this->SetMinSize(size);
	//this->SetSize(size);
	this->Update();
      }
    }

   if(elem_dialog != NULL)
      elem_dialog->RefreshDialog();


    if(mod->nobjs == 0)
        OnAddObj(event);

  }


  void ManualDialog :: OnChangeColor(wxCommandEvent& event){
    int i,n,id;

    id = event.GetId();
    n = mod->nobjs;
    for(i=0; i<n; i++){
      if(id == v_but_color[i]->GetId())
	break;
    }
    if(i<n){
      mod->obj_color[i] = v_but_color[i]->GetValue();
      APP->SetLabelColour(i+1, mod->obj_color[i]);

      APP->UpdateDensityScene();
      APP->UpdateLabel();
      APP->Refresh2DCanvas();
      APP->Refresh3DCanvas(true,1.0);
    }
  }

  void ManualDialog :: OnCheckSimpleDistribution(wxCommandEvent& event){
    APP->Control.simple = !APP->Control.simple;
  }

  void ManualDialog :: OnChangeVisibility(wxCommandEvent& event){
    int i,j,n,id;

    id = event.GetId();
    n = mod->nobjs;
    for(i=0; i<n; i++){
      if(id == v_but_eye[i]->GetId())
	break;
    }
    if(i<n){

      mod->obj_visibility[i] = v_but_eye[i]->GetValue();
      for(j=0;j < (int) APP->Data.DL.size();j++)
        if(APP->Data.DL[j].cl == i)
            APP->Data.DL[j].visible = !APP->Data.DL[j].visible;

      for(j=0;j < (int) APP->Data.labelDL.size();j++)
        if(APP->Data.labelDL[j].cl == i)
            APP->Data.labelDL[j].visible = !APP->Data.labelDL[j].visible;

      if(mod->obj_visibility[i])
	APP->SetLabelColour(i+1, mod->obj_color[i]);
      else
	APP->SetLabelColour(i+1, NIL);

      APP->UpdateLabel();
      APP->UpdateDensityScene();
      APP->Refresh2DCanvas();
      APP->Refresh3DCanvas(true,1.0);
      mod->RefreshDialogs();

    }
  }

  void ManualDialog::OnChangeMode(wxCommandEvent& event){
    ManualDialog::ModeType mode = GetOperationMode();

    if(mode==ManualDialog::PAINT){
      APP->Set2DViewInteractionHandler(xhandler, 'x');
      APP->Set2DViewInteractionHandler(yhandler, 'y');
      APP->Set2DViewInteractionHandler(zhandler, 'z');
    }
    else{
      APP->SetDefaultInteractionHandler();
    }

    xhandler->ChangeDrawMode(GetDrawMode());
    yhandler->ChangeDrawMode(GetDrawMode());
    zhandler->ChangeDrawMode(GetDrawMode());


    panel->sizer->Layout();
  }

  void ManualDialog::OnChangeDrawMode(wxCommandEvent& event)
  {
    but3->SetSelection(-1);
    xhandler->ChangeDrawMode(GetDrawMode());
    yhandler->ChangeDrawMode(GetDrawMode());
    zhandler->ChangeDrawMode(GetDrawMode());
  }

  void ManualDialog::OnChangeDrawMode2(wxCommandEvent& event)
  {
    but2->SetSelection(-1);
    xhandler->ChangeDrawMode(GetDrawMode());
    yhandler->ChangeDrawMode(GetDrawMode());
    zhandler->ChangeDrawMode(GetDrawMode());
  }

  ManualDialog::ModeType ManualDialog::GetOperationMode(){
    int sel = but->GetSelection();

    if(sel==0)      return ManualDialog::NAVIGATOR;
    else if(sel==1) return ManualDialog::PAINT;
    else            return ManualDialog::NAVIGATOR;
  }

  Manual::DrawMode ManualDialog::GetDrawMode(){
    int sel = but2->GetSelection();
    int sel2 = but3->GetSelection();
    if(sel2 == -1) {
    if(sel==0)      return Manual::ADDSPLINE;
    else if(sel==1) return Manual::ADDBEZIER;
    else if(sel==2) return Manual::ADDCIRC;
    else if(sel==3) return Manual::ADDSPIRAL;
    else            return Manual::ADDSPLINE;
    }
    else if(sel == -1)
    {
        if(sel2==0) return Manual::ADDGAUSSIAN;
        else if(sel2==1) return Manual::ADDGAUSSIANSPLINE;
        else if(sel2==2) return Manual::ADDLINEAR;
        else if(sel2==3) return Manual::ADDLINEARSPLINE;
        else if(sel2==4) return Manual::ADDOPF;

    }
    else return Manual::ADDSPLINE;
  }

  void ManualDialog::OnReset(wxCommandEvent& WXUNUSED(event)){
    mod->Reset();

   if(elem_dialog != NULL)
      elem_dialog->RefreshDialog();
  }

  void ManualDialog::OnUndo(wxCommandEvent& WXUNUSED(event)){
    //mod->Undo();
  }


  AdjRel *ManualDialog :: GetBrush(){
    return bPicker->GetBrush();
  }

  wxCursor *ManualDialog :: GetBrushCursor(int zoom){
    return bPicker->GetBrushCursor(zoom);
  }

  void ManualDialog :: NextBrush(){
    bPicker->NextBrush();
  }

  void ManualDialog :: PrevBrush(){
    bPicker->PrevBrush();
  }

  void ManualDialog :: OnCancel(wxCommandEvent& event){
    mod->Stop();
    //BaseDialog::OnCancel(event);
  }

  void ManualDialog :: OnOk(wxCommandEvent& event){
    mod->Finish();
    //BaseDialog::OnOk(event);
  }


  void ManualDialog :: OnSize(wxSizeEvent& event){
    BaseDialog::OnSize(event);
  }

  void ManualDialog :: ChangeSelection(wxPanel *bkg){
    wxPanel *panel=NULL;
    wxColour wxcolor;
    int n,i;

    n = mod->nobjs;
    for(i=0; i<n; i++){
      panel = this->v_panel_bkg[i];
      if(panel==bkg){
	mod->obj_sel = i;
	SetColor(&wxcolor, 0xffff00);
      }
      else if(i%2==0) SetColor(&wxcolor, 0xffffff);
      else     	      SetColor(&wxcolor, 0xffffdd);
      panel->SetBackgroundColour(wxcolor);
    }

    if(elem_dialog != NULL)
      elem_dialog->RefreshDialog();
  }

  //----------------------------------------------------


  BEGIN_EVENT_TABLE(ManualElementDialog, BaseDialog)
    EVT_SIZE    (       ManualElementDialog::OnSize)
  END_EVENT_TABLE()


  ManualElementDialog :: ManualElementDialog(wxWindow *parent,
					     ModuleManual *mod)
  : BaseDialog(parent, (char *)"Element Properties"){
    wxSize size(240, 380);
    wxColour wxcolor;

    this->nelems = 0;
    this->elem_sel = 0;
    this->SetMinSize(size);
    this->SetSize(size);
    this->mod = mod;

    this->nids = 0;

    panel = new BasePanel(this);
    panel->Show(true);

    //this->options_sizer = new wxStaticBoxSizer(wxVERTICAL, panel, _T("Options"));
    //this->options_sizer->AddSpacer(20);

    //panel->sizer->Add(options_sizer,   0, wxEXPAND);
    panel->sizer->AddSpacer(20);
    panel->sizer->SetSizeHints(panel);
    panel->sizer->Layout();
    this->AddPanel(panel, 0);

    this->optPanel = NULL;
    //----------ObjectPanel-------------
    this->elemPanel = this->CreateElementPanel();

    this->AddPanel((wxPanel *)elemPanel);
    //ChangeSelection(v_panel_bkg[this->elem_sel]);
  }


  ManualElementDialog::~ManualElementDialog(){
    if(v_panel_bkg != NULL) free(v_panel_bkg);
    if(v_but_trash != NULL) free(v_but_trash);
  }

  int ManualElementDialog :: FindNumberOfElements(){
    int i, n = 0;
    for(i=0; i< (int) APP->Data.DL.size();i++){
      if(APP->Data.DL[i].cl == mod->obj_sel)
	n++;
    }
    for(i=0; i< (int) APP->Data.labelDL.size();i++){
      if(APP->Data.labelDL[i].cl == mod->obj_sel)
	n++;
    }
    return n;
  }

  char **ManualElementDialog :: FindElementNames(){
    int i,j,n,type;
    int ng = 0, nc = 0, nspl = 0, nspi = 0, nlin = 0;
    char **names;
    n = this->FindNumberOfElements();

    if(n == 0) return NULL;
    names = (char **)malloc(sizeof(char *)*n);
    j = 0;
    for(i=0; i< (int) APP->Data.DL.size(); i++){
      if(APP->Data.DL[i].cl == mod->obj_sel){
	names[j] = (char*)malloc(sizeof(char)*512);
	type = APP->Data.DL[i].type;
	if(type == PSet::GAUSSIAN || type == PSet::SPLINEGAUSSIAN) sprintf(names[j], "Gaussian Distribution %02d", ++ng);
	else if(type == PSet::CIRC_RC || type == PSet::CIRC_CP ||
	   type == PSet::CIRC_C2P || type == PSet::CIRC_3P ||
	   type == PSet::CIRC_NCP){
	  sprintf(names[j], "Circle %02d", ++nc);
	}
	else if(type == PSet::LINE || type == PSet::CUBIC ||
		type == PSet::BEZIER){
	  sprintf(names[j], "Spline %02d", ++nspl);
	}
	else if(type == PSet::SPIRAL_CRNV || type == PSet::SPIRAL_CAV ||
		type == PSet::SPIRAL_CAB){
	  sprintf(names[j], "Spiral curve %02d", ++nspi);
	}
	else if(type == PSet::LINEAR)
        sprintf(names[j], "Linear Distribution %02d", ++nlin);
	else{
	  sprintf(names[j], "Unknown");
	}
	j++;
      }
    }

    for(i=0; i<APP->Data.labelDL.size(); i++){
      if(APP->Data.labelDL[i].cl == mod->obj_sel){
	names[j] = (char*)malloc(sizeof(char)*512);
	type = APP->Data.labelDL[i].type;
	if(type == PSet::GAUSSIAN || type == PSet::SPLINEGAUSSIAN) sprintf(names[j], "Gaussian Distribution %02d", ++ng);
	else if(type == PSet::CIRC_RC || type == PSet::CIRC_CP ||
	   type == PSet::CIRC_C2P || type == PSet::CIRC_3P ||
	   type == PSet::CIRC_NCP){
	  sprintf(names[j], "Circle %02d", ++nc);
	}
	else if(type == PSet::LINE || type == PSet::CUBIC ||
		type == PSet::BEZIER || type == PSet::POLY){
	  sprintf(names[j], "Spline %02d", ++nspl);
	}
	else if(type == PSet::SPIRAL_CRNV || type == PSet::SPIRAL_CAV ||
		type == PSet::SPIRAL_CAB){
	  sprintf(names[j], "Spiral curve %02d", ++nspi);
	}
    else if(type == PSet::LINEAR)
        sprintf(names[j], "Linear Distribution %02d", ++nlin);
	else{
	  sprintf(names[j], "Unknown");
	}
	j++;
      }
    }


    return names;
  }


  int ManualElementDialog::FindCurrentElementType(){
    int i, j = 0, type = -1;
    for(i=0; i<APP->Data.DL.size(); i++){
      if(APP->Data.DL[i].cl == mod->obj_sel){
	if(j == this->elem_sel){
	  type = APP->Data.DL[i].type;
	}
	j++;
      }
    }
    for(i=0; i<APP->Data.labelDL.size(); i++){
      if(APP->Data.labelDL[i].cl == mod->obj_sel){
	if(j == this->elem_sel){
	  type = APP->Data.labelDL[i].type;
	}
	j++;
      }
    }
    return type;
  }


  void ManualElementDialog::DestroyOptionsPanel(){
    if(optPanel!=NULL){

      Disconnect( this->ids[0], wxEVT_COMMAND_SPINCTRL_UPDATED,
		  wxSpinEventHandler(ManualElementDialog::OnSpinNPoints),
		  NULL, NULL );
      Disconnect( this->ids[1], wxEVT_COMMAND_SPINCTRL_UPDATED,
		  wxSpinEventHandler(ManualElementDialog::OnSpinStddev),
		  NULL, NULL );

      if(panel->sizer->GetItem(optPanel,false)!=NULL)
	panel->sizer->Detach(optPanel);
      if(optPanel->GetSizer() != NULL)
	optPanel->GetSizer()->Clear(true);
      optPanel->Destroy();
      optPanel = NULL;
    }
  }


  wxScrolledWindow *ManualElementDialog::CreateOptionsPanel(){
    if(FindNumberOfElements() == 0) return NULL;
    wxSize size(220, 120);
    int type, c_id = 0;
    wxScrolledWindow *swind = new wxScrolledWindow(this->panel, wxID_ANY,
						   wxDefaultPosition,
						   wxDefaultSize,
						   wxHSCROLL | wxVSCROLL,
						   _T("scrolledWindow"));
    type = ManualElementDialog::FindCurrentElementType();








    if(type == PSet::GAUSSIAN || type == PSet::SPLINEGAUSSIAN) {

    wxSpinCtrl  *spNpoints;
    wxBoxSizer  *hbsNpoints;

    SpinFloat   *spStdDev;
    wxBoxSizer  *hbsStdDev;

    wxStaticText *tNpoints = new wxStaticText(swind, -1, _T("N.Points"), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText1"));
    wxStaticText *tStdDev = new wxStaticText(swind, -1, _T("Std.Dev."), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText2"));

    spNpoints = new wxSpinCtrl(swind, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 1, 10000, APP->Control.NPoints, _T("wxSpinCtrl"));

    spStdDev = new SpinFloat(swind, wxID_ANY, 0.0, 100.0, APP->Control.stddev, 1.0, 5);


    wxBitmap *bmdice = new wxBitmap(dice_xpm);
    wxBitmapButton *but_trash = new wxBitmapButton(swind, wxID_ANY, *bmdice,
						   wxDefaultPosition, wxDefaultSize,
						   wxBU_AUTODRAW, wxDefaultValidator,
						   _T("dice"));
    int id = but_trash->GetId();
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualElementDialog::OnResort),
	     NULL, NULL );

    delete bmdice;


    wxStaticBoxSizer *options_sizer;
    options_sizer = new wxStaticBoxSizer(wxVERTICAL, swind, _T("Options"));
    options_sizer->AddSpacer(10);

    hbsNpoints = new wxBoxSizer(wxHORIZONTAL);
    hbsNpoints->Add(tNpoints,  1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);
    hbsNpoints->Add(spNpoints, 0, wxALIGN_RIGHT);
    options_sizer->Add(hbsNpoints,   0, wxEXPAND);

    hbsStdDev = new wxBoxSizer(wxHORIZONTAL);
    hbsStdDev->Add(tStdDev,  1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);
    hbsStdDev->Add(spStdDev, 0, wxALIGN_RIGHT);
    hbsStdDev->Add(but_trash, 0, wxALIGN_RIGHT);
    options_sizer->Add(hbsStdDev,   0, wxEXPAND);
    options_sizer->AddSpacer(10);

    this->ids[c_id] = spNpoints->GetId();

    Connect( this->ids[c_id], wxEVT_COMMAND_SPINCTRL_UPDATED,
	     wxSpinEventHandler(ManualElementDialog::OnSpinNPoints));

    c_id++;
    this->ids[c_id] = spStdDev->GetId();

    Connect( this->ids[c_id], wxEVT_COMMAND_SPINCTRL_UPDATED,
	     wxSpinEventHandler(ManualElementDialog::OnSpinStddev));

    c_id++;
    this->nids = c_id;

    swind->SetScrollRate(5, 5);
    swind->Scroll(0, 0);
    swind->SetVirtualSize(200,80);

    swind->SetSizer(options_sizer, true);
    options_sizer->SetSizeHints(swind);
    options_sizer->Layout();

    wxPaintDC paintDC(swind);
    swind->DoPrepareDC(paintDC);

    return swind;

    }

    else if(type == PSet::SPIRAL_CAV){

    SpinFloat  *spNLoops, *spVelocity;
    wxBoxSizer  *hbsNLoops, *hbsVelocity;


    wxStaticText *tNLoops = new wxStaticText(swind, -1, _T("N.Loops"), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText1"));
    wxStaticText *tVelocity = new wxStaticText(swind, -1, _T("Velocity"), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText2"));

    spNLoops = new SpinFloat(swind, wxID_ANY, 0.0, 100.0, APP->Control.NLoops, 0.1, 5);
    spVelocity = new SpinFloat(swind, wxID_ANY, 0.0, 100.0, APP->Control.Velocity, 0.1, 5);


    wxStaticBoxSizer *options_sizer;
    options_sizer = new wxStaticBoxSizer(wxVERTICAL, swind, _T("Options"));
    options_sizer->AddSpacer(10);

    hbsNLoops = new wxBoxSizer(wxHORIZONTAL);
    hbsNLoops->Add(tNLoops,  1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);
    hbsNLoops->Add(spNLoops, 0, wxALIGN_RIGHT);
    options_sizer->Add(hbsNLoops,   0, wxEXPAND);

    hbsVelocity = new wxBoxSizer(wxHORIZONTAL);
    hbsVelocity->Add(tVelocity,  1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);
    hbsVelocity->Add(spVelocity, 0, wxALIGN_RIGHT);
    options_sizer->Add(hbsVelocity,   0, wxEXPAND);
    options_sizer->AddSpacer(10);

    this->ids[c_id] = spNLoops->GetId();

    Connect( this->ids[c_id], wxEVT_COMMAND_SPINCTRL_UPDATED,
	     wxSpinEventHandler(ManualElementDialog::OnSpinNLoops));

    c_id++;
    this->ids[c_id] = spVelocity->GetId();

    Connect( this->ids[c_id], wxEVT_COMMAND_SPINCTRL_UPDATED,
	     wxSpinEventHandler(ManualElementDialog::OnSpinVelocity));

    c_id++;
    this->nids = c_id;

    swind->SetScrollRate(5, 5);
    swind->Scroll(0, 0);
    swind->SetVirtualSize(200,80);

    swind->SetSizer(options_sizer, true);
    options_sizer->SetSizeHints(swind);
    options_sizer->Layout();

    wxPaintDC paintDC(swind);
    swind->DoPrepareDC(paintDC);

    return swind;
    }

    else if(type == PSet::LINEAR)
    {
    wxSpinCtrl  *spNpoints;
    wxBoxSizer  *hbsNpoints;

    SpinFloat   *spStdDev;
    wxBoxSizer  *hbsStdDev;

    wxStaticText *tNpoints = new wxStaticText(swind, -1, _T("N.Points"), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText1"));
    wxStaticText *tStdDev = new wxStaticText(swind, -1, _T("Max. Radius"), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("staticText2"));

    spNpoints = new wxSpinCtrl(swind, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 1, 10000, APP->Control.NPoints, _T("wxSpinCtrl"));

    spStdDev = new SpinFloat(swind, wxID_ANY, 0.0, 100.0, APP->Control.LinRadius, 1.0, 5);


    wxBitmap *bmdice = new wxBitmap(dice_xpm);
    wxBitmapButton *but_trash = new wxBitmapButton(swind, wxID_ANY, *bmdice,
						   wxDefaultPosition, wxDefaultSize,
						   wxBU_AUTODRAW, wxDefaultValidator,
						   _T("dice"));
    int id = but_trash->GetId();
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED,
	     wxCommandEventHandler(ManualElementDialog::OnResort),
	     NULL, NULL );

    delete bmdice;


    wxStaticBoxSizer *options_sizer;
    options_sizer = new wxStaticBoxSizer(wxVERTICAL, swind, _T("Options"));
    options_sizer->AddSpacer(10);

    hbsNpoints = new wxBoxSizer(wxHORIZONTAL);
    hbsNpoints->Add(tNpoints,  1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);
    hbsNpoints->Add(spNpoints, 0, wxALIGN_RIGHT);
    options_sizer->Add(hbsNpoints,   0, wxEXPAND);

    hbsStdDev = new wxBoxSizer(wxHORIZONTAL);
    hbsStdDev->Add(tStdDev,  1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);
    hbsStdDev->Add(spStdDev, 0, wxALIGN_RIGHT);
    hbsStdDev->Add(but_trash, 0, wxALIGN_RIGHT);
    options_sizer->Add(hbsStdDev,   0, wxEXPAND);
    options_sizer->AddSpacer(10);

    this->ids[c_id] = spNpoints->GetId();

    Connect( this->ids[c_id], wxEVT_COMMAND_SPINCTRL_UPDATED,
	     wxSpinEventHandler(ManualElementDialog::OnSpinNPoints));

    c_id++;
    this->ids[c_id] = spStdDev->GetId();

    Connect( this->ids[c_id], wxEVT_COMMAND_SPINCTRL_UPDATED,
	     wxSpinEventHandler(ManualElementDialog::OnSpinLinRadius));

    c_id++;
    this->nids = c_id;

    swind->SetScrollRate(5, 5);
    swind->Scroll(0, 0);
    swind->SetVirtualSize(200,80);

    swind->SetSizer(options_sizer, true);
    options_sizer->SetSizeHints(swind);
    options_sizer->Layout();

    wxPaintDC paintDC(swind);
    swind->DoPrepareDC(paintDC);

    return swind;
    }

    else {

    /*
    swind->SetScrollRate(5, 5);
    swind->Scroll(0, 0);
    swind->SetVirtualSize(200,80);

    wxPaintDC paintDC(swind);
    swind->DoPrepareDC(paintDC);*/

    return swind;

    }




    /*
    if(type == PSet::CIRC_RC || type == PSet::CIRC_CP ||
       type == PSet::CIRC_C2P || type == PSet::CIRC_3P ||
       type == PSet::CIRC_NCP){


    }
    else if(type == PSet::LINE || type == PSet::CUBIC ||
	    type == PSet::BEZIER){
      SpinFloat   *spPower;
      wxBoxSizer  *hbsPower;

      wxSpinCtrl  *spBand;
      wxBoxSizer  *hbsBand;

      wxCheckBox  *cbAdaptive;
      wxBoxSizer  *hbsAdaptive;
    }

    if(type == PSet::SPIRAL_CRNV || type == PSet::SPIRAL_CAV ||
	    type == PSet::SPIRAL_CAB){

    }
    else{

    }
    */

  }




  void ManualElementDialog :: OnSpinStddev(wxSpinEvent& event){
    //wxString A = event.GetString();
    // printf("Viva: %s\n",A.ToAscii());
    //std::cout << A.ToAscii() << std::endl;
    float SDev;
    wxObject  *O;
    SpinFloat *S;
    O = event.GetEventObject();
    S = (SpinFloat *)O;
    SDev = S->GetValue();
    APP->Control.stddev = SDev;
  }

  void ManualElementDialog :: OnSpinNPoints(wxSpinEvent& event){
    //APP->Data.NPoints = event.GetInt();
   APP->Control.NPoints = event.GetInt();
  }

  void ManualElementDialog :: OnSpinNLoops(wxSpinEvent& event)
  {
    wxObject  *O;
    SpinFloat *S;
    O = event.GetEventObject();
    S = (SpinFloat *)O;
    APP->Control.NLoops = S->GetValue();

  }
  void ManualElementDialog :: OnSpinVelocity(wxSpinEvent& event)
  {
    wxObject  *O;
    SpinFloat *S;
    O = event.GetEventObject();
    S = (SpinFloat *)O;
    APP->Control.Velocity = S->GetValue();
  }


  wxScrolledWindow *ManualElementDialog::CreateElementPanel(){
    int i,n,id,w,h,wm=200;
    wxSize size(220, 120);
    wxPanel *bkg;
    char **names;

    wxScrolledWindow *swind = new wxScrolledWindow(this, wxID_ANY,
						   wxDefaultPosition,
						   wxDefaultSize,
						   wxHSCROLL | wxVSCROLL,
						   _T("scrolledWindow"));

    swind->SetMinSize(size);
    wxBitmap *bmtrash = new wxBitmap(trash_xpm);

    names = this->FindElementNames();
    n = this->FindNumberOfElements();
    this->nelems = n;

    if(n>0){
      v_panel_bkg = (wxPanel **)malloc(sizeof(wxPanel *)*n);
      v_but_trash = (wxBitmapButton **)malloc(sizeof(wxBitmapButton *)*n);
    }
    else{
      v_panel_bkg = NULL;
      v_but_trash = NULL;
    }

    swind->SetScrollRate(5, 5);
    swind->Scroll(0, 0);
    swind->SetVirtualSize(200,10+MAX(40*n,40));

    for(i=0; i<n; i++){
      size.SetHeight(wxDefaultCoord);
      size.SetWidth(200);
      bkg = new ObjBkgPanel(swind,
			    wxPoint(10,10+40*i),
			    wxDefaultSize,
			    this, 1);
      bkg->SetMinSize(size);
      v_panel_bkg[i] = bkg;
      v_but_trash[i] = new wxBitmapButton(bkg, wxID_ANY, *bmtrash,
					  wxDefaultPosition, wxDefaultSize,
					  wxBU_AUTODRAW, wxDefaultValidator,
					  _T("trash"));

      id = v_but_trash[i]->GetId();
      Connect( id, wxEVT_COMMAND_BUTTON_CLICKED,
	       wxCommandEventHandler(ManualElementDialog::OnDelete),
	       NULL, NULL );

      wxString *wxstr = new wxString(names[i], wxConvUTF8);
      ObjLabel *tname = new ObjLabel(bkg, *wxstr, this, 1);
      size.SetHeight(wxDefaultCoord);
      size.SetWidth(120);
      //tname->SetSize(size);
      tname->SetMinSize(size);
      wxBoxSizer *hsizer = new wxBoxSizer(wxHORIZONTAL);
      hsizer->Add(v_but_trash[i], 0, wxALIGN_RIGHT|wxEXPAND);
      hsizer->AddSpacer(10);
      hsizer->Add(tname,          1, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL);

      bkg->SetSizer(hsizer, true);
      hsizer->SetSizeHints(bkg);
      hsizer->Layout();

      bkg->GetSize(&w, &h);
      if(w>wm) wm = w;
    }

    for(i=0; i<n; i++){
      size.SetHeight(wxDefaultCoord);
      size.SetWidth(wm);
      (v_panel_bkg[i])->SetSize(size);
    }
    swind->SetVirtualSize(wm,10+MAX(40*n,40));

    wxPaintDC paintDC(swind);
    swind->DoPrepareDC(paintDC);

    if(n > 0){
      for(i=0; i<n; i++)
	free(names[i]);
      free(names);
    }
    delete bmtrash;

    return (swind);
  }


  void ManualElementDialog::DestroyElementPanel(){
    int i,n,id;

    n = this->nelems;
    for(i=0; i<n; i++){
      if(v_but_trash==NULL) break;
      id = v_but_trash[i]->GetId();
      Disconnect( id, wxEVT_COMMAND_BUTTON_CLICKED,
		  wxCommandEventHandler(ManualElementDialog::OnDelete),
		  NULL, NULL );
    }
    if(v_panel_bkg!=NULL) free(v_panel_bkg);
    if(v_but_trash!=NULL) free(v_but_trash);
    v_panel_bkg = NULL;
    v_but_trash = NULL;

    if(elemPanel!=NULL){
      if(sizer->GetItem(elemPanel,false)!=NULL)
	sizer->Detach(elemPanel);
      elemPanel->Destroy();
      elemPanel = NULL;
    }
  }


  void ManualElementDialog :: OnDelete(wxCommandEvent& event){
    wxSize size(240, 380);
    char msg[1024];
    int i,n,id,index;
    char **names;
    PSet::DataList *p = NULL;

    id = event.GetId();
    n = this->nelems;
    if(n == 0 || n != this->FindNumberOfElements()) return;

    names = this->FindElementNames();
    for(i=0; i<n; i++){
      if(id == v_but_trash[i]->GetId())
	break;
    }
    if(i<n){
      sprintf(msg,"Do you really wish to delete the %s?",names[i]);

      wxString wxmsg(msg, wxConvUTF8);
      wxMessageDialog *dialog = new wxMessageDialog(this, wxmsg,
						    _T("Delete Confirmation"),
						    wxYES_NO | wxICON_QUESTION,
						    wxDefaultPosition);
      if(dialog->ShowModal() == wxID_YES){
	this->RefreshDialog();


    index = GetPointSetIndex(&p, mod->obj_sel, i);
    p->erase(p->begin()+index);

    /*
    if(APP->Control.DLType[mod->obj_sel][i] == LABEL)
        APP->Data.labelDL.erase(APP->Data.labelDL.begin() + APP->Control.GetIndex(mod->obj_sel, i, LABEL));

    else if(APP->Control.DLType[mod->obj_sel][i] == DATA)
        APP->Data.DL.erase(APP->Data.DL.begin() + APP->Control.GetIndex(mod->obj_sel, i, DATA));*/


	this->DestroyElementPanel();
	//mod->DeleteObj(i);

	this->SetMinSize(size);
	this->SetSize(size);
	elemPanel = this->CreateElementPanel();
	this->AddPanel((wxPanel *)elemPanel);
	if(this->elem_sel>=0 && v_panel_bkg!=NULL)
	  ChangeSelection(v_panel_bkg[this->elem_sel]);
	//this->Fit();
	this->SetMinSize(size);
	this->SetSize(size);
	this->Update();

    APP->UpdateLabel();
    APP->UpdateDensityScene();
    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);

      }
    }
    if(n > 0){
      for(i=0; i<n; i++)
	free(names[i]);
      free(names);
    }
  }


  void ManualElementDialog :: RefreshDialog(){
    wxSize size(240, 380);
    this->DestroyElementPanel();

    this->SetMinSize(size);
    this->SetSize(size);
    elemPanel = this->CreateElementPanel();
    this->AddPanel((wxPanel *)elemPanel);
    if(this->elem_sel>=0 &&
       this->elem_sel<this->nelems && v_panel_bkg!=NULL)
      ChangeSelection(v_panel_bkg[this->elem_sel]);
    else
      this->RefreshOptions();

/*    PSet::PointSet *PS;
    PS = GetPointSet();
    if(PS != NULL)
        APP->Control.CurrentPointSet = PS;  */

    //this->Fit();
    this->SetMinSize(size);
    this->SetSize(size);
    this->Update();
  }


  void ManualElementDialog :: RefreshOptions(){
    this->DestroyOptionsPanel();
    optPanel = this->CreateOptionsPanel();

    if(optPanel != NULL){
      this->panel->sizer->Prepend(optPanel, 1, wxEXPAND);
      //this->panel->SetSizer(this->panel->sizer, true);
    }
    this->panel->sizer->SetSizeHints(this->panel);
    this->panel->sizer->Layout();
    //this->panel->Refresh(true, NULL);
    //this->panel->Update();
    this->Update();
  }

  void ManualElementDialog :: OnCancel(wxCommandEvent& event){
    /*
    mod->Stop();
    BaseDialog::OnCancel(event);*/
  }

  void ManualElementDialog :: OnOk(wxCommandEvent& event){
    /*
    mod->Finish();
    BaseDialog::OnOk(event);*/
        OnResort(event);
/*
    PSet::DataList *p = NULL;
    int index = GetPointSetIndex(&p, mod->obj_sel, elem_sel);

    APP->Data.DL[index].clear();
    APP->Data.DL[index].AddGaussianDistribution(APP->Data.DL[index].ctrlfloat[0], APP->Data.DL[index].ctrlfloat[1], APP->Data.DL[index].ctrl[0]);
    APP->UpdateDensityScene();
    APP->UpdateLabel();
    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);*/

  }


  void ManualElementDialog :: OnSize(wxSizeEvent& event){
    BaseDialog::OnSize(event);
  }

  void ManualElementDialog :: ChangeSelection(wxPanel *bkg){
    wxPanel *panel=NULL;
    wxColour wxcolor;
    int n,i, m=0, type;

    n = this->nelems;
    for(i=0; i<n; i++){
      panel = this->v_panel_bkg[i];
      if(panel==bkg){
	this->elem_sel = i;
	SetColor(&wxcolor, 0xffff00);

      }
      else if(i%2==0) SetColor(&wxcolor, 0xffffff);
      else     	      SetColor(&wxcolor, 0xffffdd);
      panel->SetBackgroundColour(wxcolor);

    }
    type = FindCurrentElementType();
    if(type == PSet::CIRC_RC || type == PSet::CIRC_CP || type == PSet::CIRC_C2P || type == PSet::CIRC_3P || type == PSet::CIRC_NCP || type == PSet::LINE ||
       type == PSet::CUBIC || type == PSet::BEZIER || type == PSet::SPIRAL_CRNV || type == PSet:: SPIRAL_CAV || type == PSet:: SPIRAL_CAB || type == PSet:: POLY) {
    for(i=0;i<APP->Data.DL.size();i++)
        if(APP->Data.DL[i].cl == mod->obj_sel)
         m++;
    APP->Control.CurrentSpline = APP->Data.labelDL.GetSpline(mod->obj_sel, this->elem_sel - m);
    }
    this->RefreshOptions();

}

  PSet::PointSet* ManualElementDialog :: GetPointSet(){
     int i, j=0;
     PSet::PointSet *PS;

     for(i=0; i< (int) APP->Data.DL.size(); i++){
     if(APP->Data.DL[i].cl == mod->obj_sel){
	 if(j == this->elem_sel)
	  PS = &APP->Data.DL[i];
	j++;
      }
    }

    for(i=0; i< (int) APP->Data.labelDL.size(); i++){
      if(APP->Data.labelDL[i].cl == mod->obj_sel){
	if(j == this->elem_sel)
	  PS = &APP->Data.labelDL[i];

	j++;
      }
    }

    return PS;


  }

    void ManualElementDialog :: OnResort(wxCommandEvent& event){

    PSet::DataList *p = NULL;
    PSet::PointSet *PS;
    int index = GetPointSetIndex(&p, mod->obj_sel, elem_sel);
    PS = &((*p)[index]);
    PS->clear();
    int i;
    if(PS->type == PSet::GAUSSIAN) {
        PS->AddGaussianDistribution(APP->Control.NPoints, APP->Control.stddev, PS->ctrl[0]);
        PS->setcl(PS->cl);
    }
    else if(PS->type == PSet::LINEAR) {
        PS->AddLinearDistribution(APP->Control.NPoints, APP->Control.LinRadius, PS->ctrl[0]);
        PS->setcl(PS->cl); }
    else if(PS->type == PSet::SPLINEGAUSSIAN) {
        if(APP->Control.simple == false)
            PS->AddGaussianDistributionAlongSpline(APP->Control.NPoints, APP->Control.stddev, *APP->Control.CurrentSpline);
        else
             PS->AddSimpleGaussianDistributionAlongSpline(APP->Control.NPoints, APP->Control.stddev, *APP->Control.CurrentSpline);

        PS->setcl(PS->cl);
    }
    else if(PS->type == PSet::SPIRAL_CAV) {
        APP->Control.CurrentSpline->Ctrl[0] = APP->Control.Velocity;
        APP->Control.CurrentSpline->b = 2*PI*APP->Control.NLoops;
        PS->AddSpline(*APP->Control.CurrentSpline, 1);
        }

    this->RefreshOptions();
    APP->UpdateDensityScene();
    APP->UpdateLabel();
    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);

    }

    int ManualElementDialog :: GetSplineStartIndex()
    {
        int i, n=0, type;
        for(i=0;i<nelems;i++) {
            type = FindCurrentElementType();
            if(type == PSet::GAUSSIAN || type == PSet::SPLINEGAUSSIAN || type == PSet::LINEAR)
                    n++;
        }
        return n;
    }

    void ManualElementDialog :: OnSpinLinRadius(wxSpinEvent& event)
    {
        float R;
        wxObject  *O;
        SpinFloat *S;
        O = event.GetEventObject();
        S = (SpinFloat *)O;
        R = S->GetValue();
        APP->Control.LinRadius = R;
    }


  //----------------------------------------------------

BEGIN_EVENT_TABLE(ObjBkgPanel, wxPanel)
  EVT_MOUSE_EVENTS(ObjBkgPanel::OnMouseEvent)
END_EVENT_TABLE()

  ObjBkgPanel :: ObjBkgPanel(wxWindow *parent,
			     const wxPoint& pos,
			     const wxSize& size,
			     BaseDialog  *dialog,
			     int type)
    : wxPanel(parent, wxID_ANY, pos, size, wxTAB_TRAVERSAL, _T("panel_bkg")){

    this->dialog = dialog;
    this->type = type;
  }

  ObjBkgPanel :: ~ObjBkgPanel(){
  }

  void ObjBkgPanel :: OnMouseEvent(wxMouseEvent& event){
    switch (event.GetButton()) {
    case wxMOUSE_BTN_LEFT :
      if(event.GetEventType() == wxEVT_LEFT_DOWN){
	if(type == 0)
	  ((ManualDialog*)dialog)->ChangeSelection((wxPanel *)this);
	else
	  ((ManualElementDialog*)dialog)->ChangeSelection((wxPanel *)this);
      }
      break;
    case wxMOUSE_BTN_RIGHT :
      if (event.GetEventType() == wxEVT_RIGHT_DOWN){
	if(type == 0)
	  ((ManualDialog*)dialog)->ChangeSelection((wxPanel *)this);
	else
	  ((ManualElementDialog*)dialog)->ChangeSelection((wxPanel *)this);
      }
      break;
    }
  }

  //----------------------------------------------------

BEGIN_EVENT_TABLE(ObjLabel, wxStaticText)
  EVT_MOUSE_EVENTS(ObjLabel::OnMouseEvent)
END_EVENT_TABLE()

  ObjLabel :: ObjLabel(wxWindow *parent,
		       const wxString& label,
		       BaseDialog *dialog,
		       int type)
    : wxStaticText(parent, wxID_ANY, label, wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT, _T("obj_label")){

    this->dialog = dialog;
    this->type = type;
  }

  ObjLabel :: ~ObjLabel(){
  }

  void ObjLabel :: OnMouseEvent(wxMouseEvent& event){
    switch (event.GetButton()) {
    case wxMOUSE_BTN_LEFT :
      if(event.GetEventType() == wxEVT_LEFT_DOWN){
	if(type == 0)
	  ((ManualDialog*)dialog)->ChangeSelection((wxPanel *)this->GetParent());
	else
	  ((ManualElementDialog*)dialog)->ChangeSelection((wxPanel *)this->GetParent());
      }
      break;
    case wxMOUSE_BTN_RIGHT :
      if (event.GetEventType() == wxEVT_RIGHT_DOWN){
	if(type == 0)
	  ((ManualDialog*)dialog)->ChangeSelection((wxPanel *)this->GetParent());
	else
	  ((ManualElementDialog*)dialog)->ChangeSelection((wxPanel *)this->GetParent());
      }
      break;
    }
  }



} //end Manual namespace


