
#include "modulemanual.h"
//#include "manualopt.h"
#include "manualdialog.h"

#ifdef _WIN32
#include <windows.h>
#endif

namespace Manual{

  ModuleManual :: ModuleManual()
    : DrawModule(){
    SetName((char *)"Manual");
    SetAuthor((char *)"Carlos Augusto Prete Junior");
    SoftwareVersion ver(2,0,0);
    SetVersion(ver);

    optDialog = NULL;

    obj_visibility[0] = true;
    obj_color[0] = 0xffff00;
    obj_name[0][0] = '\0';
    obj_sel = 0;
    nobjs = 0;
  }


  ModuleManual :: ~ModuleManual(){
  }

  void ModuleManual :: Start(){
    int i;

    APP->EnableObjWindow(false);
    APP->ResetData();

    obj_visibility[0] = true;
    /*
    r = APP->ShowNewObjDialog(&this->obj_color[0],
			      this->obj_name[0]);
    if (r!=0) return;
    */

    //--------------------------------------

    this->active = true;
    this->nobjs = APP->Control.ClassColor.size();
    for(i=0;i<nobjs;i++) {
        this->obj_color[i] = APP->Control.ClassColor[i];
        sprintf(this->obj_name[i], "class %d", i+1);
    }

    this->obj_sel = 0;
    APP->SetLabelColour(0, NIL);
    //APP->SetLabelColour(1, this->obj_color[0]);

    this->AllocData();
    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);

  }


  void ModuleManual :: AllocData(){
    int x,y,w,h;

    if(optDialog!=NULL) delete optDialog;
    ManualDialog *dialog = new ManualDialog(APP->Window, this);
    optDialog = (BaseDialog*)dialog;
    optDialog->Show(true);
    APP->Window->GetPosition(&x, &y);
    APP->Window->GetSize(&w, &h);
    optDialog->Move(MAX(x-20,0), h/2); //wxDefaultCoord);
  }



  bool ModuleManual :: Stop(){
  /*static const char *title = {"Keep segmentation?"};
    static const char *msg = {
      "You are about to leave the manual module.\nSave changes?"};

    if(!this->active) return true;

    wxString wxtitle(title, wxConvUTF8);
    wxString wxmsg(msg, wxConvUTF8);

    wxMessageDialog dialog(APP->Window,
			   wxmsg, wxtitle,
			   wxYES_NO | wxICON_QUESTION,
			   wxDefaultPosition);

    if(dialog.ShowModal() == wxID_YES)*/
      this->Finish();

    return true;
  }


  void ModuleManual :: FreeData(){
    //APP->DetachOptPanel(optPanel);
    APP->SetDefaultInteractionHandler();
    APP->EnableObjWindow(true);
    APP->ResetData();
    //APP->DrawSegmObjects();
    this->active = false;

    optDialog->Show(false);
    if(optDialog!=NULL)
      optDialog->Destroy(); //delete optDialog;
    optDialog = NULL;
  }


  void ModuleManual :: Finish(){
    int n;
    Scene *label = APP->Data.label;

    n = APP->Data.w*APP->Data.h*APP->Data.nframes;

    this->FreeData();
  }



  void ModuleManual :: Reset(){
    wxMessageDialog dialog(APP->Window,
			   _T("Current segmentation will be lost.\nAre you sure you want to reset?"),
			   _T("Reset segmentation?"),
			   wxYES_NO | wxICON_QUESTION,
			   wxDefaultPosition);

    if(dialog.ShowModal() == wxID_YES){
      APP->ResetData();
      APP->Refresh2DCanvas();
      APP->Refresh3DCanvas(true, 1.0);
    }
  }

  void ModuleManual :: RefreshDialogs(){
    ManualDialog *opt = (ManualDialog *)optDialog;
    if(opt->elem_dialog != NULL)
      opt->elem_dialog->RefreshDialog();





  }

  AdjRel *ModuleManual :: GetBrush(){
    ManualDialog *opt = (ManualDialog *)optDialog;
    return opt->GetBrush();
  }

  wxCursor *ModuleManual :: GetBrushCursor(int zoom){
    ManualDialog *opt = (ManualDialog *)optDialog;
    return opt->GetBrushCursor(zoom);
  }

  void   ModuleManual :: NextBrush(){
    ManualDialog *opt = (ManualDialog *)optDialog;
    opt->NextBrush();
  }

  void   ModuleManual :: PrevBrush(){
    ManualDialog *opt = (ManualDialog *)optDialog;
    opt->PrevBrush();
  }

  void ModuleManual :: DeleteObj(int obj){
    int o,p,lb, i, k;

    APP->Control.ClassColor.erase(APP->Control.ClassColor.begin() + i);

    //if(obj_sel < APP->Control.DLType.size() - 1) APP->Control.DLType.erase(APP->Control.DLType.begin() + obj_sel);

    for(o=obj ; o<this->nobjs-1; o++){
      APP->SetLabelColour(o+1, this->obj_color[o+1]);
      obj_color[o] = obj_color[o+1];
      obj_visibility[o] = obj_visibility[o+1];
      //strcpy(obj_name[o], obj_name[o+1]);
    }
    this->nobjs--;
    if(obj_sel>nobjs-1) this->obj_sel--;

    for(p=0; p<(APP->Data.label)->n; p++){
      lb = (APP->Data.label)->data[p];
      if(lb==obj+1){
	(APP->Data.label)->data[p] = 0;
      }
      else if(lb>obj+1)
	(APP->Data.label)->data[p] = lb-1;
    }



    APP->Data.DL.EraseClass(obj);
    APP->Data.labelDL.EraseClass(obj);

    APP->UpdateDensityScene();
    APP->UpdateLabel();
    APP->Refresh2DCanvas();
    APP->Refresh3DCanvas(true,1.0);
  }


} //end Manual namespace


